<?php

class microconfig {
	function microconfig($configfile)
	{
		$this->_configfile = $configfile;
		$cfile = dirname($this->_configfile) . '/' . basename(strtolower($this->_configfile), '.php') . '.cfg.php';
		if(file_exists($cfile))
		{
			include_once($cfile);
			if(isset($micro_cfg))
			{
				if($options = get_object_vars($micro_cfg))
				{
					foreach($options as $o_name => $o_value)
					{
						if($o_name{0} != '_')	
						{
							$this->$o_name = $o_value;
						}
					}
				}
			}
		}
	}

	function get_config_descriptions()
	{
		$thisfile = implode('', file($this->_configfile));
		preg_match("|/\* BEGIN CONFIG VARS \*/(.*)/\* END CON" . "FIG VARS \*/|ims", $thisfile, $matches);
		preg_match_all('/var \\$([a-z_]*) = ((\\"([^\\"]|\\\\\\")*\\")|(true|false|[0-9]+)); \/\/(.*)/i', $matches[1], $descs, PREG_SET_ORDER);
		foreach($descs as $desc)
		{
			$opts = explode(':', $desc[6]);
			$newdescs[$desc[1]]['description'] = $opts[0];
			$newdescs[$desc[1]]['format'] = trim($opts[1]);
			$newdescs[$desc[1]]['value'] = $this->$desc[1];
		}
		return $newdescs;
	}

	function write_post()
	{
		return $this->write($_POST);
	}

	function write($newoptions)
	{
		$options = get_object_vars($this);
		if(!isset($newoptions['config'])) return false;

		$cdesc = $this->get_config_descriptions();

		$outputvars = '';
		$thisfile = '';
		foreach($options as $o_name => $o_value)
		{
			if(isset($newoptions[$o_name]))
			{
				$o_value = stripslashes($newoptions[$o_name]);
				if($o_value == 'false' || $o_value == 'true')
				{
					$this->$o_name = ($o_value == 'true') ? true : false;
				}
				else if(is_numeric($o_value))
				{
					$this->$o_name = 0 + $o_value;
				}
				else
				{
					$this->$o_name = $o_value;
				}
			}
		}

		$thisfile = '<'.'?php $micro_cfg=unserialize("' . addslashes(serialize($this)) . '");?'.'>';

		$cfile = dirname($this->_configfile) . '/' . basename(strtolower($this->_configfile), '.php') . '.cfg.php';
		if(!file_exists($cfile) || is_writable($cfile))
		{
			$h = fopen($cfile, 'w');
			fwrite($h, $thisfile);
			fclose($h);
			return true;
		}
		else
		{
			echo "Config file '{$cfile}' not write-enabled.";
			$this->_thisfile = htmlentities($thisfile);
			return false;
		}
	}

	function editform($echo = false)
	{
		$options = get_object_vars($this);

		$cdesc = $this->get_config_descriptions();
		$output = '<form method="post"><dl>';
		foreach($options as $o_name => $o_value)
		{
			if($o_name{0} != '_')
			{
				if($cdesc[$o_name]['format'] == '')
				{
					$output .= '<dt>' . trim($cdesc[$o_name]['description']) . ":</dt>\n<dd><input type=\"text\" name=\"{$o_name}\" value=\"{$o_value}\" /></dd>\n";
				}
				else if($cdesc[$o_name]['format'] == 'TEXTAREA')
				{
					$output .= '<dt>' . trim($cdesc[$o_name]['description']) . ":</dt>\n<dd><textarea style=\"width:400px;height:100px;\" name=\"{$o_name}\">{$o_value}</textarea></dd>\n";
				}
				else
				{
					$opts = explode(',', $cdesc[$o_name]['format']);
					$output .= '<dt>' . $cdesc[$o_name]['description'] . ":</dt>\n<dd>\n";
					foreach($opts as $opt)
					{
						$sopt = trim($opt, "'\"");
						$output .= "<label><input type=\"radio\" name=\"{$o_name}\" value=\"{$opt}\" ";
						$value = $cdesc[$o_name]['value'];
						if($opt == 'true' || $opt == 'false')
						{
							if(($opt == 'true') && ($value === true)) $output .= 'checked="checked" ';
							if(($opt == 'false') && ($value === false)) $output .= 'checked="checked" ';
						}
						else if($value == $opt)
						{
							$output .= 'checked="checked" ';
						}
						$output .= "/>{$sopt}</label><br/>\n";
					}
					$output .= "</dd>\n";
				}
			}
		}
		$output .= "</dl>
		<input type=\"submit\" name=\"Submit\" value=\"Commit Changes\" />
		<input type=\"hidden\" name=\"config\" value=\"editform\" />
		</form>
		";
		if($echo) echo $output;
		return $output;
	}

	var $_thisfile;
	var $_configfile;
}


class microsession {

	var $_sessionname;

	function microsession($sessionname)
	{
		$session = @unserialize(@gzuncompress(@base64_decode($_COOKIE[$sessionname])));
		$vars = get_object_vars($session);
		if(is_array($vars))
		{
			foreach($vars as $name => $value)
			{
				$this->$name = $value;
			}
		}
		$this->_sessionname = $sessionname;
		$this->activate_session();
		ob_start();
		//echo '<pre>'.print_r($_sessionname,1).'</pre>';
	}
	
	function activate_session()
	{
	// Virtual function
	}

	function save($sessionname = '')
	{
		if($sessionname == '') $sessionname = $this->_sessionname;
		$vars = get_object_vars($this);
		foreach($vars as $name => $value)
		{
			if($name{0} != '_')	$session->$name = $value;
		}

		setcookie($sessionname, base64_encode(gzcompress(serialize($session))), time()+60*60*6, '/');
	}

	function is_auth()
	{
		global $cookiehash;
		
		$auth = false;
		$login = array();
		if((!empty($_COOKIE['wordpressuser_'.$cookiehash])) && (!empty($_COOKIE['wordpresspass_'.$cookiehash])))
		{
			$login['wp']->user = $_COOKIE['wordpressuser_'.$cookiehash];
			$login['wp']->pass = $_COOKIE['wordpresspass_'.$cookiehash];
		}
		if(isset($_POST['microsession_user']) && isset($_POST['microsession_pass']))
		{
			$login['post']->user = $_POST['microsession_user'];
			$login['post']->pass = md5(md5($_POST['microsession_pass']));
		}
		if(isset($this->session_password))
		{
			$login['session']->user = $this->session_username;
			$login['session']->pass = $this->session_password;
		}
		foreach($login as $k => $l)
		{
			if($this->do_auth($l->user, $l->pass))
			{
				$this->session_username = $l->user;
				$this->session_password = $l->pass;
				$this->save();
				$auth = true;
				break;
			}
		}
		return $auth;
	}

	function auth_form($fn = false)
	{
		$auth = $this->is_auth();
		if(!$auth)
		{
			if(is_callable($fn))
			{
				$fn();
			}
			else
			{
				$this->login_form();
			}
		}
		return $auth;
	}

	function do_auth($user, $pass, $level = 0 /* $pass is alread md5 */) //virtual
	{
		if(function_exists('get_userdatabylogin'))
		{
			global $wpdb, $wp_version;
			if($wp_version >= '1.6') {
				$userdata = new WP_User($user);
				//owd($userdata->has_cap('administrator'));
				return (($pass == md5($userdata->data->user_pass)) && (($userdata->has_cap($level)) || ($userdata->data->user_level >= $level)));
			}
			else {
				$userdata = get_userdatabylogin($user);
				return (($pass == md5($userdata->user_pass)) && ($userdata->user_level >= $level));
			}

		}
		else
		{
			$this->session_username = $user;
			$this->session_password = $pass;
			$this->save();
			return false;
		}
	}

	function login_form()
	{
		if(isset($_POST['microsession_user']))
		{
			echo "<div id=\"specialmessage\">Sorry, that login is incorrect.</div>";
		}
		echo "<form id=\"microauth\" method=\"post\">\n";
		echo "<dl><dt>Username:</dt><dd><input type=\"text\" name=\"microsession_user\" value=\"{$this->session_username}\" /></dd>\n";
		echo "<dt>Password:</dt><dd><input type=\"password\" name=\"microsession_pass\" value=\"{$this->session_password}\" /></dd></dl>\n";
		echo "<input type=\"submit\" name=\"submit\" value=\"Log In\" />\n";
		echo "</form>";
	}
}



/* DATABASE SUPPORT FUNCTIONS */
class microdb {

	var $pdb;
	var $dberror;
	var $lastquery;
	var $config;

	function microdb(&$config)
	{
		$this->config = &$config;
		if(isset($config->UseWordPressDB) && ($config->UseWordPressDB === true))
		{
			$server = DB_HOST;
			$user = DB_USER;
			$password = DB_PASSWORD;
			$name = DB_NAME;
		}
		else {
			$server = $config->db_server;
			$user = $config->db_user;
			$password = $config->db_password;
			$name = $config->db_name;
		}

		if(!($this->pdb = @mysql_connect($server, $user, $password)))
		{
			$this->dberror = "Database server, username, or password is incorrect.";
			return false;
		}
		else
		{
			if(!(mysql_select_db($name, $this->pdb)))
			{
				$this->dberror = "Specified user does not have access to a database with that name on the server.";
				return false;
			}
		}
		return true;
	}

	function query($qry)
	{
		$this->lastquery = $qry;
		$tableres = @mysql_query($qry, $this->pdb);
		$err = mysql_error();
		if($err != '') {
			$this->dberror = $err;
			return false;
		}
		return true;
	}

	function get_results($qry, $type='object')
	{
		$this->lastquery = $qry;
		$tableres = @mysql_query($qry, $this->pdb);
		$err = @mysql_error($this->pdb);
		if($err != '') {
			$this->dberror = $err;
			return false;
		}
		$ary = array();
		switch($type)
		{
		case 'object': $fn = 'mysql_fetch_object'; break;
		case 'row': $fn = 'mysql_fetch_row'; break;
		case 'assoc': $fn = 'mysql_fetch_assoc'; break;
		}
		while($row = @$fn($tableres))
		{
			$ary[] = $row;
		}
		return $ary;
	}

	function get_row($qry, $type='object')
	{
		$this->lastquery = $qry;
		$tableres = @mysql_query($qry, $this->pdb);
		$err = @mysql_error($this->pdb);
		if($err != '') {
			$this->dberror = $err;
			return false;
		}
		switch($type)
		{
		case 'object': $fn = 'mysql_fetch_object'; break;
		case 'row': $fn = 'mysql_fetch_row'; break;
		case 'assoc': $fn = 'mysql_fetch_assoc'; break;
		}
		return @$fn($tableres);
	}

	function get_col($qry, $index = 0)
	{
		$this->lastquery = $qry;
		$tableres = @mysql_query($qry, $this->pdb);
		$err = @mysql_error($this->pdb);
		if($err != '') {
			$this->dberror = $err;
			return false;
		}
		$ary = array();
		while($row = @mysql_fetch_array($tableres, MYSQL_BOTH))
		{
			$ary[] = $row[$index];
		}
		return $ary;
	}

	function get_var($qry)
	{
		$this->lastquery = $qry;
		if($tableres = @mysql_query($qry, $this->pdb))
		{
			$err = mysql_error($this->pdb);
			if($err != '') {
				$this->dberror = $err;
				return null;
			}
			$ary = mysql_fetch_row($tableres);
			return $ary[0];
		}
		else
		{
			$err = @mysql_error($this->pdb);
			if($err != '') {
				$this->dberror = $err;
				return null;
			}
			return null;
		}
	}

	function insert_id()
	{
		return mysql_insert_id($this->pdb);
	}

	function get_error($echo = false)
	{
		$res = "<div style=\"border:1px dashed red;background-color:#FCC;width:100%;\">{$this->dberror}<hr style=\"color:red;\" />{$this->lastquery}</div>";
		if($echo) echo $res;
		return $res;
	}

	function result_table($qry, $tableid = '', $showcolumns = null, $headings = null)
	{
		$tableid = "id=\"{$tableid}\"";
		echo "<table {$tableid}>\n";
		if(is_string($qry))
		{
			$results = $this->get_results($qry, 'assoc');
		}
		else
		{
			$results = $qry;
		}
		if($results)
		{
			if($showcolumns == null)
			{
				$showcolumns = array_keys($results[0]);
			}
			if($headings == null)
			{
				$headings = $showcolumns;
			}
			echo "<thead><tr>\n";
			foreach($headings as $heading)
			{
				echo "<th>{$heading}</th>\n";
			}
			echo "</tr></thead>\n";
			echo "<tbody>\n";
			foreach($results as $result)
			{
				echo "<tr>\n";
				foreach($showcolumns as $column)
				{
					echo "<td>{$result[$column]}</td>\n";
				}
				echo "</tr>\n";
			}
			echo "</tbody>\n";
		}
		else
		{
			echo "<tr><td>No results</td></tr>";
		}
		echo "</table>";
	}

	function table_exists($tablename)
	{
		$tables = $this->get_col('SHOW TABLES;');
		return in_array($tablename, $tables);
	}

	function upgrade($queries, $execute = true, $silent = true) {
		if( !is_array($queries) ) {
			$queries = explode( ';', $queries );
			if('' == $queries[count($queries) - 1]) array_pop($queries);
		}

		$cqueries = array();
		$iqueries = array();
		$for_update = array();

		foreach($queries as $qry) {
			if(preg_match("|CREATE TABLE ([^ ]*)|", $qry, $matches)) {
				$cqueries[strtolower($matches[1])] = $qry;
				$for_update[$matches[1]] = 'Created table '.$matches[1];
			}
			else if(preg_match("|CREATE DATABASE ([^ ]*)|", $qry, $matches)) {
				array_unshift($cqueries, $qry);
			}
			else if(preg_match("|INSERT INTO ([^ ]*)|", $qry, $matches)) {
				$iqueries[] = $qry;
			}
			else if(preg_match("|UPDATE ([^ ]*)|", $qry, $matches)) {
				$iqueries[] = $qry;
			}
			else {
				// Unrecognized query type
			}
		}

		if($tables = $this->get_col('SHOW TABLES;')) {
			foreach($tables as $table) {
				if( array_key_exists(strtolower($table), $cqueries) ) {
					unset($cfields);
					unset($indices);
					preg_match("|\((.*)\)|ms", $cqueries[strtolower($table)], $match2);
					$qryline = trim($match2[1]);

					$flds = explode("\n", $qryline);
					foreach($flds as $fld) {
						preg_match("|^([^ ]*)|", trim($fld), $fvals);
						$fieldname = $fvals[1];
						$validfield = true;
						switch(strtolower($fieldname))
						{
						case '':
						case 'primary':
						case 'index':
						case 'fulltext':
						case 'unique':
						case 'key':
							$validfield = false;
							$indices[] = trim(trim($fld), ", \n");
							break;
						}
						$fld = trim($fld);
						if($validfield) {
							$cfields[strtolower($fieldname)] = trim($fld, ", \n");
						}
					}
					$tablefields = $this->get_results("DESCRIBE {$table};");
					foreach($tablefields as $tablefield) {
						if(array_key_exists(strtolower($tablefield->Field), $cfields)) {
							preg_match("|".$tablefield->Field." ([^ ]*( unsigned)?)|i", $cfields[strtolower($tablefield->Field)], $matches);
							$fieldtype = $matches[1];
							if($tablefield->Type != $fieldtype) {
								$cqueries[] = "ALTER TABLE {$table} CHANGE COLUMN {$tablefield->Field} " . $cfields[strtolower($tablefield->Field)];
								$for_update[$table.'.'.$tablefield->Field] = "Changed type of {$table}.{$tablefield->Field} from {$tablefield->Type} to {$fieldtype}";
							}
							if(preg_match("| DEFAULT '(.*)'|i", $cfields[strtolower($tablefield->Field)], $matches)) {
								$default_value = $matches[1];
								if($tablefield->Default != $default_value)
								{
									$cqueries[] = "ALTER TABLE {$table} ALTER COLUMN {$tablefield->Field} SET DEFAULT '{$default_value}'";
									$for_update[$table.'.'.$tablefield->Field] = "Changed default value of {$table}.{$tablefield->Field} from {$tablefield->Default} to {$default_value}";
								}
							}
							unset($cfields[strtolower($tablefield->Field)]);
						}
						else {
							// This field exists in the table, but not in the creation queries?
						}
					}
					foreach($cfields as $fieldname => $fielddef) {
						$cqueries[] = "ALTER TABLE {$table} ADD COLUMN $fielddef";
						$for_update[$table.'.'.$fieldname] = 'Added column '.$table.'.'.$fieldname;
					}
					$tableindices = $this->get_results("SHOW INDEX FROM {$table};");

					if($tableindices) {
						unset($index_ary);
						foreach($tableindices as $tableindex) {
							$keyname = $tableindex->Key_name;
							$index_ary[$keyname]['columns'][] = array('fieldname' => $tableindex->Column_name, 'subpart' => $tableindex->Sub_part);
							$index_ary[$keyname]['unique'] = ($tableindex->Non_unique == 0)?true:false;
						}
						foreach($index_ary as $index_name => $index_data) {
							$index_string = '';
							if($index_name == 'PRIMARY') {
								$index_string .= 'PRIMARY ';
							}
							else if($index_data['unique']) {
								$index_string .= 'UNIQUE ';
							}
							$index_string .= 'KEY ';
							if($index_name != 'PRIMARY') {
								$index_string .= $index_name;
							}
							$index_columns = '';
							foreach($index_data['columns'] as $column_data) {
								if($index_columns != '') $index_columns .= ',';
								$index_columns .= $column_data['fieldname'];
								if($column_data['subpart'] != '') {
									$index_columns .= '('.$column_data['subpart'].')';
								}
							}
							$index_string .= ' ('.$index_columns.')';

							if(!(($aindex = array_search($index_string, $indices)) === false)) {
								unset($indices[$aindex]);
							}
						}
					}
					foreach($indices as $index) {
						$cqueries[] = "ALTER TABLE {$table} ADD $index";
						$for_update[$table.'.'.$fieldname] = 'Added index '.$table.' '.$index;
					}
					unset($cqueries[strtolower($table)]);
					unset($for_update[strtolower($table)]);
				} else {
				}
			}
		}

		$allqueries = array_merge($cqueries, $iqueries);
		if($execute) {
			foreach($allqueries as $query) {
				if(!$this->query($query))
				{
					$this->get_error(true);
				}
			}
		}

		if(!$silent)
		{
			if(count($for_update) > 0)
			{
				echo "<ul>\n";
				foreach($for_update as $upgrade)
				{
					echo "<li>{$upgrade}</li>\n";
				}
				echo "</ul>\n";
			}
			else
			{
			echo "<ul><li>No Upgrades</li></ul>";
			}
		}

		return $for_update;
	}

}

/*
Parameters:
modify_qs(newkey, newvalue, oldquery_or_uri) or
modify_qs(associative_array, oldquery_or_uri)
*/
function modify_qs() {

	$REQUEST_URI = ( isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : $_SERVER['SCRIPT_NAME'] . (( isset($_SERVER['QUERY_STRING']) ? '?' . $_SERVER['QUERY_STRING'] : '')));


	$ret = '';
	if(is_array(func_get_arg(0))) {
		if (@func_num_args() < 2) {
			$uri = $REQUEST_URI;
		} else {
			$uri = @func_get_arg(1);
		}
	}
	else {
		if (@func_num_args() < 3) {
			$uri = $REQUEST_URI;
		} else {
			$uri = @func_get_arg(2);
		}
	}

	if (strstr($uri, '?')) {
		$parts = explode('?', $uri, 2);
		if (1 == count($parts)) {
			$base = '?';
			$query = $parts[0];
		}
		else {
			$base = $parts[0] . '?';
			$query = $parts[1];
		}
	}
	else {
		$base = $uri . '?';
		$query = '';
	}
	parse_str($query, $qs);
	if (is_array(func_get_arg(0))) {
		$kayvees = func_get_arg(0);
		$qs = array_merge($qs, $kayvees);
	}
	else
    {
			$qs[func_get_arg(0)] = func_get_arg(1);
    }

	foreach($qs as $k => $v)
    {
			if($v != '')
        {
					if($ret != '') $ret .= '&';
					$ret .= "$k=$v";
        }
    }
	$ret = $base . $ret;
	return trim($ret, '?');
}

function match_scheme($url)
{
	$purl = parse_url($url);
	
	$scheme = ($_SERVER["HTTPS"] == 'on')?'https':'http';
	if($purl['query'] != '') $purl['query'] = '?' . $purl['query'];
	return "{$scheme}://{$purl['host']}{$purl['path']}{$purl['query']}";
}


class microrewrite {
	var $rules = array();
	var $links = array();
	var $basename = '';
	var $using_rewrite = false;

	function compact()
	{	
		$setvars = array();
		$stub = ( isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : $_SERVER['SCRIPT_NAME'] . ( isset($_SERVER['PATH_INFO']) ? $_SERVER['PATH_INFO'] : '') . ( (isset($_SERVER['QUERY_STRING']) && ($_SERVER['QUERY_STRING'] != '')) ? '?' . $_SERVER['QUERY_STRING'] : ''));
		$base = parse_url($this->basename);
		$stub = substr($stub, strpos($stub, $base['path']) + strlen($base['path']));
		$stub = urldecode($stub);
		if($_SERVER['QUERY_STRING'] != '')
			$stub = substr($stub, 0, strlen($stub) - strlen($_SERVER['QUERY_STRING']) - 1);
		$this->stub = $stub;
		foreach($this->rules as $rulename => $rule)
		{
			$vars = explode(',', $rule[1]);
			foreach($vars as $varname)
			{
				if(isset($_GET[$varname]))
				{
					$setvars[$varname] = $_GET[$varname];	
				}
			}
			//owd($rule[0] . "\n" . $stub);
			if(preg_match($rule[0], $stub, $matches))
			{
				for($z=0;$z<count($vars);$z++)
				{
					$setvars[$vars[$z]] = $matches[$z+1];
				}
				$this->using_rewrite = true;
				$this->ruleresults['match'][] = $rulename;
				break;
			}
			else
			{
				$this->ruleresults['nomatch'][] = $rulename;
			}
		}
		$this->setvars = $setvars;
		return $setvars;
	}
	
	function get_link($linkary)
	{
		$topscore = -1;
		$linkmatch = '';
		$matchary = array();
		foreach($this->links as $link)
		{
			preg_match_all('/%([^%]+)%/', $link, $matches);
			$thisscore = 0;
			foreach($matches[1] as $insertion)
			{
				if(array_key_exists($insertion, $linkary)) $thisscore ++;
			}
			$thisscore -= abs(count($matches[1]) - count($linkary));
			if(count($matches[1]) > 0)
			{
				$thisscore = $thisscore / count($linkary);
			}
			else
			{
				$thisscore = 0;
			}
			if($thisscore > $topscore)
			{
				$topscore = $thisscore;
				$linkmatch = $link;
				$matchary = $matches[1];
			}
		}

		$missing = array_diff(array_keys($linkary), $matchary);		
		$outlink = $this->basename . preg_replace('/%([^%]+)%/e', '\$linkary[\'\\1\']', $linkmatch);
		if(count($missing) > 0)
		{
			$featurechar = '?';
			foreach($missing as $miss)
			{
				$outlink .= "{$featurechar}{$miss}={$linkary[$miss]}";
				$featurechar = '&';
			}
		}
		return $outlink;
	}
	
	function init_rules()
	{
	}
	
	function microrewrite($thisfile)
	{
		$this->basename = $thisfile;
		
		$this->init_rules();
	}
}

class microtemplate {
	var $template;
	var $fields = array();
	
	function microtemplate($template) {
		$this->template = $template;
	}
	
	function set_field($name, $value) {
		$this->fields[$name] = $value;
	}
	
	function regex_map_field($value) {
		return "/<!--{$value}-->/i";
	}

	function render($clear = true) {
		$tests = array_map(array(&$this, 'regex_map_field') , array_keys($this->fields));
		$output = preg_replace($tests, $this->fields, $this->template);
		while(preg_match('/<!--if(not)?:(.*?)-->(.*?)<!--\/if\\1?:\\2-->/si', $output, $match)) {
			$rematch = str_replace(array('/', '.', '*', '+', '[', ']', '{', '}', "\n", "\r", "\t", '?', '$'), array('\\/', '\\.', '\\*', '\\+', '\\[', '\\]', '\\{', '\\}', '\\s', '\\s', '\\s', '\\?', '\\$'), $match[0]);
			$rematch = preg_replace('/(\\\\s)+/', '\s+', $rematch);
			$rematch = '/' . $rematch . '/si';
			if($match[1] == 'not') {
				if (empty($this->fields[$match[2]])) {
					$output = preg_replace($rematch, $match[3], $output);
				} 
				else {
					$output = preg_replace($rematch, '', $output);
				}
			}
			else {
				if (isset($this->fields[$match[2]])) {
					$output = preg_replace($rematch, $match[3], $output);
				} 
				else {
					$output = preg_replace($rematch, '', $output);
				}
			}
			if($oldoutput==$output) {owd('Template match caused endless loop:', $rematch);die();}
			$oldoutput = $output;
		}
		if($clear) $fields = array();
		return $output;
	}
}

function owd()
{
	$args = func_get_args();
	echo "<pre style=\"background-color:#ffeeee;border:1px solid red;\">";
	foreach($args as $arg1)
	{
		echo htmlentities(print_r($arg1, 1)) . "<br/>";
	}
	echo "</pre>";
}

?>